local Network = require('lneural.network')
local Data    = require('lneural.data')

local train   = Data.new_from_file('train.data')
local test    = Data.new_from_file('test.data')

local net     = Network.new(60, 20, 1)
net:set_activation_function('sigmoid_symmetric')

net.eta              = 0.2
net.increase_factor  = 1
net.decrease_factor  = 0.99

local cb      = net:progress_callback(20)
net:train(train, 0.0001, 10000, cb)
net:validate(test, true)
