local Net = require('lneural.network')
local Data = require('lneural.data')

local function timeit(f)
    local init = os.clock()
    f()
    return os.clock() - init
end

local net  = Net.new(10, 9, 8)
net:set_activation_function('elliot')
local data = Data.new(10,8) data:add{1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0}
local N, input = 100000, {1,2,3,4,5,6,7,8,9,10}

print('* Training *')

local NT = N / 5
local total = timeit( function() net:train(data, 0, NT) end )
print( 'Epochs per second:\t' .. math.floor(NT / total) )

print('* Execution *')

local out, NE = {}, N
local total = timeit( function() for i = 1, NE do net:run(input, nil, out) end end )
print('Runs per second:\t' .. math.floor(NE / total))

