local Network = require('lneural.network')
local Data    = require('lneural.data')

local train   = Data.new_from_file('train.data')
local test    = Data.new_from_file('test.data')

-- check if there's an already trained network
local fname   = 'thyroid.net'
local f       = io.open(fname)
local exists  = f ~= nil

if exists then
    e = true
    f:close()
end

local net

if exists then
    net     = Network.new_from_file(fname)
else
    net     = Network.new(21, 4, 3)
    net.eta = 1
    local cb    = net:progress_callback(10)
    local m, e  = net:train(train, 0.015, 1000, cb)
    print('Epochs: ' .. e)
    net:save_to_file(fname)
end

net:validate(test, true)
