--[[
	This file is part of lneural.

	lneural is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lneural is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lneural.  If not, see <http://www.gnu.org/licenses/>.
	
	Copyright (C) 2010 Lucas Hermann Negri
--]]

local S     = {}

local ti, tc, sf = table.insert, table.concat, string.format

function S.string(val)
    return sf('%q', val)
end

function S.number(val)
    if math.floor(val) == val then return tostring(val) end
    
    local val = sf('%e', val):gsub(',', '.')
    return val
end

function S.table(val)
    local aux = { '{', }
    
    for k, v in pairs(val) do
        if type(v) ~= 'function' then
            ti(aux, sf('\t[%s] = %s,', S(k), S(v) ) )
        end
    end
    
    ti(aux, '}')
    
    return tc(aux, '\n')
end

S['function'] = function(val)
    return 'nil'
end

setmetatable(S, {
    __index = function()
        return tostring 
    end,
    
    __call  = function(tbl, val)
        return S[ type(val) ]( val )
    end
})

return S
